module NML
implicit none

contains

subroutine ZR30(Fun, C, Eps1, Eps2, Eps3, Eta, Max, Cnt)
!   C[i]  
! , 1<=i<=N, N>=1
interface
  real function Fun(x)
    real, intent(in):: x
  end function Fun
end interface
real, intent(inout):: C(:)
real, intent(in):: Eps1, Eps2, Eps3, Eta
integer, intent(in):: Max
integer:: Cnt(:)
integer i, j, k, n
real P,P1,P2,X0,X1,X2,R,F,F1,D,E,H,U,V,W,T
!begin
  n=size(C)
  do k=1, n
    if (C(k)==0.0) then
      P=-1.0; P1=1.0; P2=0.0
    else
      P=-0.9*C(k); P1=1.1*C(k); P2=C(k)
    endif
    j=0; R=P; goto 80
10 continue
    R=P1; X0=F1; goto 80
20 continue
    R=P2; X1=F1; goto 80
30 continue
    X2=F1; D=-0.5
    if (C(k)==0.0) then; H=-1.0; else; H=-0.1*C(k); endif
1000 continue  !iter
    E=1.0+D
    T=X0*D*D-X1*E*E+X2*(D+E)
    U=T*T-4.0*X2*D*E*(X0*D-X1*E+X2)
    if (U<0.0) then; U=0.0; else; U=Sqrt(U); endif
    V=T+U; W=T-U
    if (Abs(V)<=Abs(W)) then; U=W; else; U=V; endif
    if (U==0.0) U=1.0
    T=-2.0*X2*E/U; H=T*H;
    R=R+H
    if (Abs(H/R)<Eps1) goto 90
    goto 80
40 continue
    if (Abs(F1)<Abs(10.0*X2)) then
      X0=X1; X1=X2; X2=F1; D=T
      goto 1000
    endif
    T=0.5*T; H=0.5*H
    if ((1.0+Abs(T))==1.0 .or. (1.0+Abs(H))==1.0) goto 100
    R=R-H
80 continue  !reg
    j=j+1;
90 continue  !calc
    F=Fun(R); F1=F
    if (j>=Max) goto 100
    do i=1, k-1
      E=R-C(i)
      if (Abs(E)>=Eps3) then
        F1=F1/E
      else
        R=R+Eta; goto 90
      endif
    enddo
    if ((Abs(F)<Eps2) .and. (Abs(F1)<Eps2)) goto 100
    if (j>=4) goto 40
    if (j==1) goto 10
    if (j==2) goto 20
    goto 30  !(j=3)
100 continue
    C(k)=R; Cnt(k)=j
  enddo
  return
end subroutine ZR30

end module NML
